/* include standard header */
#include "php.h"

/* include Tine headers */
#include "rpctypes.h"
#include "errors.h"
#include "swaplib.h"
#include "toolkit.h"

extern void php_info_print_table_row();
extern void php_info_print_table_end();
extern void php_info_print_table_start();

/* why isn't this in rpctypes.h ?? */
typedef struct
{
	float f1val;
	float f2val;
} FLTFLT;

/* declaration of functions to be exported */
ZEND_FUNCTION(tine_get);
ZEND_FUNCTION(tine_info);
ZEND_FUNCTION(tine_put);
PHP_MINFO_FUNCTION(tinemod);

/* compiled function list so Zend knows whats in this module */
zend_function_entry tinemod_functions[] = 
{
	ZEND_FE(tine_get, NULL)
	ZEND_FE(tine_info, NULL)
	ZEND_FE(tine_put, NULL)
	{NULL, NULL, NULL}
};

/* compiled module information */
zend_module_entry tinemod_module_entry =
{
	STANDARD_MODULE_HEADER,
	"Tine",
	tinemod_functions,
	NULL,
	NULL,
	NULL,
	NULL,
	PHP_MINFO(tinemod),
	NO_VERSION_YET,
	STANDARD_MODULE_PROPERTIES
};

/* implement standard stub routine to introduce ourselves to Zend */
#if COMPILE_DL_TINE_MOD
	ZEND_GET_MODULE(tinemod)
#endif

PHP_MINFO_FUNCTION(tinemod)
{ 
	php_info_print_table_start(); 
	php_info_print_table_row(2, "Tine Support", "enabled"); 
	php_info_print_table_end(); 
}

short ftoi(char *fmt)
{
	char *c, fmtstr[64];
	short ifmt;
	
	strncpy(fmtstr, fmt, 64);
	if ((c = strchr(fmtstr, '.')) != NULL) *c = 0;
	strupr(fmtstr);
	if ((ifmt = getSimpleFormatType(fmtstr)) != CF_NULL) return ifmt;
	return getCompoundFormatType(fmtstr);
}

char *itof(int fmt)
{
	static char s[64];
	switch (LFMT(fmt))  
	{                 
		case CF_BYTE: return "BYTE";
		case CF_SHORT: return "short";
		case CF_LONG: return "UINT32";
		case CF_FLOAT: return "float";
		case CF_DOUBLE: return "double";
		case CF_TEXT: return "char";
		case CF_NAME8: return "NAME8";
		case CF_NAME16: return "NAME16";
		case CF_NAME32: return "NAME32";
		case CF_NAME48: return "NAME48";
		case CF_NAME64: return "NAME64";
		case CF_LNGINT: return "LNGINT";
		case CF_FLTINT: return "FLTINT";
		case CF_DBLDBL: return "DBLDBL";
		case CF_NAME8I: return "NAME8I";
		case CF_NAME16I: return "NAME16I";
		case CF_NAME32I: return "NAME32I";
		case CF_NAME48I: return "NAME48I";
		case CF_NAME64I: return "NAME64I";
		case CF_NAME16FI: return "NAME16FLTINT";
		case CF_NAME16II: return "NAME16INTINT";
		case CF_INTFLTINT: return "INTFLTINT";
		case CF_FLTINTINT: return "FLTINTINT";
		case CF_FLTFLTINT: return "FLTFLTINT";
		case CF_FILTER: return "FILTER";
		case CF_ADDRESS: return "ADDRESS";
		case CF_USTRING: return "USTRING";
		case CF_SPECTRUM: return "SPECTRUM";
		case CF_POINT: return "POINT";
		case CF_WINDOW: return "WINDOW";
		case CF_BOOLEAN: return "BOOLEAN";
		case CF_IIFF: return "IIFF";
		case CF_FIFI: return "FIFI";
		default: break;
	}
	sprintf(s, "d", LFMT(fmt));
	return s;
}

short GetPropertyInformation(char *srv,char *prp,PropertyQueryStruct *srvProps)
{
	DTYPE dout, din;
	int cc = 0;
 
	din.dFormat = CF_NAME32;
	din.dArrayLength = 1;
	din.data.vptr = prp;

	dout.dFormat = CF_STRUCT;
	dout.dArrayLength = PROPERTYQUERYSTRUCT_SIZE;
	dout.data.vptr = srvProps;

	if ((cc=ExecLinkEx(srv,"PROPS",&dout,&din,CA_READ,500)) != 0) return cc;
	
	srvProps->prpSize = ISWAP(srvProps->prpSize);
	
	return 0;
}

short _tget(void *buf, char *dev, char *prp, int fmt, int len, int tmr)
{
	DTYPE dout;

	dout.dFormat = fmt;
	dout.dArrayLength = len;
	dout.dTag[0] = 0;
	dout.data.vptr = buf;

	return ExecLinkEx(dev, prp, &dout, NULL, CA_READ, (UINT16)tmr);
}

short _tput(void *buf, char *dev, char *prp, int fmt, int len, int tmr)
{
	DTYPE din;

	din.dFormat = fmt;
	din.dArrayLength = len;
	din.dTag[0] = 0;
	din.data.vptr = buf;

	return ExecLinkEx(dev, prp, NULL, &din, CA_WRITE, (UINT16)tmr);
}

ZEND_FUNCTION(tine_get)
{
    char *parm, *prop, *sfmt;
    int i, j, s_len, size, fmt;
    short cc;
	double blob[8000];
	char s[65];

	fmt = CF_DEFAULT;
	size = sizeof(blob);

	switch (ZEND_NUM_ARGS())
	{
		case 4:
			if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ssls", &parm, &s_len, &prop, 
				&s_len, &size, &sfmt) == FAILURE) return;
			fmt = ftoi(sfmt);
			break;
		default: 
			if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ss", &parm, &s_len, &prop, 
				&s_len) == FAILURE)	return;
	}

	if ((cc = _tget(blob, parm, prop, fmt, size, 5000)) != 0) 
    {
		while (cc == invalid_transport_size || cc == use_stream_transport)
		{
			size /= 2; 
			if (size < 1000) RETURN_STRING(GetRPCLastError(cc), 1);
			cc = _tget(blob, parm, prop, fmt, size, 5000);
		}
	}

	if (cc == 0)
    {
		fmt = GetCompletionDataType(-1);
		size = GetCompletionDataSize(-1);
        
		array_init(return_value);

		switch (fmt)
		{
			case CF_BYTE:
				for (i = 0; i < size; i++)
					add_index_long(return_value, i, ((BYTE *)blob)[i]);
				break;
			case CF_SHORT:
				for (i = 0; i < size; i++)
					add_index_long(return_value, i, ((short *)blob)[i]);
				break;
			case CF_BIT: /* are CF_BIT really transported in 4 bytes ?? */
			case CF_BOOLEAN:
			case CF_LONG:
				for (i = 0; i < size; i++)
					add_index_long(return_value, i, ((UINT32 *)blob)[i]);
				break;
			case CF_FLOAT:
				for (i = 0; i < size; i++)
					add_index_double(return_value, i, ((float *)blob)[i]);
				break;
			case CF_DOUBLE:
				for (i = 0; i < size; i++)
					add_index_double(return_value, i, blob[i]);
				break;
			case CF_TEXT:
				RETURN_STRING((char *)blob, 1);
				break;
			case CF_NAME8:
				for (i = 0; i < size; i++) 
				{
					strncpy(s, ((NAME8 *)blob)[i].name, 8);
					add_index_string(return_value, i, s, 1);
				}
				break;
			case CF_NAME16:
				for (i = 0; i < size; i++) 
				{
					strncpy(s, ((NAME16 *)blob)[i].name, 16);
					add_index_string(return_value, i, s, 1);
				}
				break;
			case CF_NAME32:
				for (i = 0; i < size; i++)
				{
					strncpy(s, ((NAME32 *)blob)[i].name, 32);
					add_index_string(return_value, i, s, 1);
				}
				break;
			case CF_NAME48:
				for (i = 0; i < size; i++)
				{
					strncpy(s, ((NAME32 *)blob)[i].name, 48);
					add_index_string(return_value, i, s, 1);
				}
				break;
			case CF_NAME64:
				for (i = 0; i < size; i++)
				{
					strncpy(s, ((NAME32 *)blob)[i].name, 64);
					add_index_string(return_value, i, s, 1);
				}
				break;
			case CF_FLTFLT:
				for (i = 0; i < size; i++)
				{
					zval *tmp_arr;
					MAKE_STD_ZVAL(tmp_arr);
					array_init(tmp_arr);
					add_index_double(tmp_arr, 0, ((FLTFLT *)blob)[i].f1val);
					add_index_double(tmp_arr, 1, ((FLTFLT *)blob)[i].f2val);
					add_index_zval(return_value, i, tmp_arr);
				}
				break;
			case CF_FLTINT:
				for (i = 0; i < size; i++)
				{
					zval *tmp_arr;
					MAKE_STD_ZVAL(tmp_arr);
					array_init(tmp_arr);
					add_index_double(tmp_arr, 0, ((FLTINT *)blob)[i].fval);
					add_index_long(tmp_arr, 1, ((FLTINT *)blob)[i].ival);
					add_index_zval(return_value, i, tmp_arr);
				}
				break;
			case CF_LNGINT:
				for (i = 0; i < size; i++)
				{
					zval *tmp_arr;
					MAKE_STD_ZVAL(tmp_arr);
					array_init(tmp_arr);
					add_index_long(tmp_arr, 0, ((LNGINT *)blob)[i].lval);
					add_index_long(tmp_arr, 1, ((LNGINT *)blob)[i].ival);
					add_index_zval(return_value, i, tmp_arr);
				}
				break;
			case CF_DBLDBL:
				for (i = 0; i < size; i++)
				{
					zval *tmp_arr;
					MAKE_STD_ZVAL(tmp_arr);
					array_init(tmp_arr);
					add_index_double(tmp_arr, 0, ((DBLDBL *)blob)[i].d1val);
					add_index_double(tmp_arr, 1, ((DBLDBL *)blob)[i].d2val);
					add_index_zval(return_value, i, tmp_arr);
				}
				break;
			case CF_NAME8I:
				for (i = 0; i < size; i++) 
				{
					zval *tmp_arr;
					MAKE_STD_ZVAL(tmp_arr);
					array_init(tmp_arr);
					strncpy(s, ((NAME8I *)blob)[i].name, 8);
					add_index_string(tmp_arr, 0, s, 1);
					add_index_long(tmp_arr, 1, ((NAME8I *)blob)[i].ival);
					add_index_zval(return_value, i, tmp_arr);
				}
				break;
			case CF_NAME16I:
				for (i = 0; i < size; i++) 
				{
					zval *tmp_arr;
					MAKE_STD_ZVAL(tmp_arr);
					array_init(tmp_arr);
					strncpy(s, ((NAME16I *)blob)[i].name, 16);
					add_index_string(tmp_arr, 0, s, 1);
					add_index_long(tmp_arr, 1, ((NAME16I *)blob)[i].ival);
					add_index_zval(return_value, i, tmp_arr);
				}
				break;
			case CF_NAME32I:
				for (i = 0; i < size; i++) 
				{
					zval *tmp_arr;
					MAKE_STD_ZVAL(tmp_arr);
					array_init(tmp_arr);
					strncpy(s, ((NAME32I *)blob)[i].name, 32);
					add_index_string(tmp_arr, 0, s, 1);
					add_index_long(tmp_arr, 1, ((NAME32I *)blob)[i].ival);
					add_index_zval(return_value, i, tmp_arr);
				}
				break;
			case CF_NAME48I:
				for (i = 0; i < size; i++) 
				{
					zval *tmp_arr;
					MAKE_STD_ZVAL(tmp_arr);
					array_init(tmp_arr);
					strncpy(s, ((NAME48I *)blob)[i].name, 48);
					add_index_string(tmp_arr, 0, s, 1);
					add_index_long(tmp_arr, 1, ((NAME48I *)blob)[i].ival);
					add_index_zval(return_value, i, tmp_arr);
				}
				break;
			case CF_NAME64I:
				for (i = 0; i < size; i++) 
				{
					zval *tmp_arr;
					MAKE_STD_ZVAL(tmp_arr);
					array_init(tmp_arr);
					strncpy(s, ((NAME64I *)blob)[i].name, 64);
					add_index_string(tmp_arr, 0, s, 1);
					add_index_long(tmp_arr, 1, ((NAME64I *)blob)[i].ival);
					add_index_zval(return_value, i, tmp_arr);
				}
				break;
			case CF_NAME16FI:
				for (i = 0; i < size; i++) 
				{
					zval *tmp_arr;
					MAKE_STD_ZVAL(tmp_arr);
					array_init(tmp_arr);
					strncpy(s, ((NAME16FI *)blob)[i].name, 16);
					add_index_string(tmp_arr, 0, s, 1);
					add_index_double(tmp_arr, 1, ((NAME16FI *)blob)[i].fval);
					add_index_long(tmp_arr, 2, ((NAME16FI *)blob)[i].ival);
					add_index_zval(return_value, i, tmp_arr);
				}
				break;
			case CF_NAME16II:
				for (i = 0; i < size; i++) 
				{
					zval *tmp_arr;
					MAKE_STD_ZVAL(tmp_arr);
					array_init(tmp_arr);
					strncpy(s, ((NAME16II *)blob)[i].name, 16);
					add_index_string(tmp_arr, 0, s, 1);
					add_index_long(tmp_arr, 1, ((NAME16II *)blob)[i].ival1);
					add_index_long(tmp_arr, 2, ((NAME16II *)blob)[i].ival2);
					add_index_zval(return_value, i, tmp_arr);
				}
				break;
			case CF_NAME16DBLDBL:
				for (i = 0; i < size; i++) 
				{
					zval *tmp_arr;
					MAKE_STD_ZVAL(tmp_arr);
					array_init(tmp_arr);
					strncpy(s, ((NAME16DBLDBL *)blob)[i].name, 16);
					add_index_string(tmp_arr, 0, s, 1);
					add_index_double(tmp_arr, 1, ((NAME16DBLDBL *)blob)[i].d1val);
					add_index_double(tmp_arr, 2, ((NAME16DBLDBL *)blob)[i].d2val);
					add_index_zval(return_value, i, tmp_arr);
				}
				break;
			case CF_INTFLTINT:
				for (i = 0; i < size; i++)
				{
					zval *tmp_arr;
					MAKE_STD_ZVAL(tmp_arr);
					array_init(tmp_arr);
					add_index_long(tmp_arr, 0, ((INTFLTINT *)blob)[i].i1val);
					add_index_double(tmp_arr, 1, ((INTFLTINT *)blob)[i].fval);
					add_index_long(tmp_arr, 2, ((INTFLTINT *)blob)[i].i2val);
					add_index_zval(return_value, i, tmp_arr);
				}
				break;
			case CF_FLTFLTINT:
				for (i = 0; i < size; i++)
				{
					zval *tmp_arr;
					MAKE_STD_ZVAL(tmp_arr);
					array_init(tmp_arr);
					add_index_double(tmp_arr, 0, ((FLTFLTINT *)blob)[i].f1val);
					add_index_double(tmp_arr, 1, ((FLTFLTINT *)blob)[i].f2val);
					add_index_long(tmp_arr, 2, ((FLTFLTINT *)blob)[i].ival);
					add_index_zval(return_value, i, tmp_arr);
				}
				break;
			case CF_FLTINTINT:
				for (i = 0; i < size; i++)
				{
					zval *tmp_arr;
					MAKE_STD_ZVAL(tmp_arr);
					array_init(tmp_arr);
					add_index_double(tmp_arr, 0, ((FLTINTINT *)blob)[i].fval);
					add_index_long(tmp_arr, 1, ((FLTINTINT *)blob)[i].i1val);
					add_index_long(tmp_arr, 2, ((FLTINTINT *)blob)[i].i2val);
					add_index_zval(return_value, i, tmp_arr);
				}
				break;
			case CF_INTINTINT:
				for (i = 0; i < size; i++)
				{
					zval *tmp_arr;
					MAKE_STD_ZVAL(tmp_arr);
					array_init(tmp_arr);
					add_index_double(tmp_arr, 0, ((INTINTINT *)blob)[i].ival1);
					add_index_long(tmp_arr, 1, ((INTINTINT *)blob)[i].ival2);
					add_index_long(tmp_arr, 2, ((INTINTINT *)blob)[i].ival3);
					add_index_zval(return_value, i, tmp_arr);
				}
				break;
			case CF_FILTER:
				for (i = 0; i < size; i++)
				{
					zval *tmp_arr;
					MAKE_STD_ZVAL(tmp_arr);
					array_init(tmp_arr);
					add_index_long(tmp_arr, 0, ((DFILTER *)blob)[i].ival);
					add_index_double(tmp_arr, 1, ((DFILTER *)blob)[i].f1val);
					add_index_double(tmp_arr, 2, ((DFILTER *)blob)[i].f2val);
					add_index_double(tmp_arr, 3, ((DFILTER *)blob)[i].f3val);
					add_index_zval(return_value, i, tmp_arr);
				}
				break;
			case CF_ADDRESS:
				for (i = 0; i < size; i++)
				{
					zval *tmp_arr;
					MAKE_STD_ZVAL(tmp_arr);
					array_init(tmp_arr);
					add_index_long(tmp_arr, 0, ((DADDRESS *)blob)[i].i1val);
					add_index_long(tmp_arr, 1, ((DADDRESS *)blob)[i].i2val);
					add_index_long(tmp_arr, 2, ((DADDRESS *)blob)[i].i3val);
					add_index_long(tmp_arr, 3, ((DADDRESS *)blob)[i].i4val);
					add_index_zval(return_value, i, tmp_arr);
				}
				break;
			case CF_WINDOW:
				for (i = 0; i < size; i++)
				{
					zval *tmp_arr;
					MAKE_STD_ZVAL(tmp_arr);
					array_init(tmp_arr);
					add_index_long(tmp_arr, 0, ((DWINDOW *)blob)[i].t1);
					add_index_long(tmp_arr, 1, ((DWINDOW *)blob)[i].t2);
					add_index_long(tmp_arr, 2, ((DWINDOW *)blob)[i].i1val);
					add_index_long(tmp_arr, 3, ((DWINDOW *)blob)[i].i2val);
					add_index_zval(return_value, i, tmp_arr);
				}
				break;
			case CF_FWINDOW:
				for (i = 0; i < size; i++)
				{
					zval *tmp_arr;
					MAKE_STD_ZVAL(tmp_arr);
					array_init(tmp_arr);
					add_index_long(tmp_arr, 0, ((FWINDOW *)blob)[i].i1val);
					add_index_long(tmp_arr, 1, ((FWINDOW *)blob)[i].i2val);
					add_index_double(tmp_arr, 2, ((FWINDOW *)blob)[i].f1val);
					add_index_double(tmp_arr, 3, ((FWINDOW *)blob)[i].f2val);
					add_index_zval(return_value, i, tmp_arr);
				}
				break;
			case CF_FLTINTFLTINT:
				for (i = 0; i < size; i++)
				{
					zval *tmp_arr;
					MAKE_STD_ZVAL(tmp_arr);
					array_init(tmp_arr);
					add_index_double(tmp_arr, 0, ((FLTINTFLTINT *)blob)[i].f1val);
					add_index_long(tmp_arr, 1, ((FLTINTFLTINT *)blob)[i].i1val);
					add_index_double(tmp_arr, 2, ((FLTINTFLTINT *)blob)[i].f2val);
					add_index_long(tmp_arr, 3, ((FLTINTFLTINT *)blob)[i].i2val);
					add_index_zval(return_value, i, tmp_arr);
				}
				break;
			case CF_USTRING:
				for (i = 0; i < size; i++) 
				{
					zval *tmp_arr;
					MAKE_STD_ZVAL(tmp_arr);
					array_init(tmp_arr);
					add_index_long(tmp_arr, 0, ((DUSTRING *)blob)[i].ival);
					add_index_double(tmp_arr, 1, ((DUSTRING *)blob)[i].f1val);
					add_index_double(tmp_arr, 2, ((DUSTRING *)blob)[i].f2val);
					add_index_long(tmp_arr, 3, ((DUSTRING *)blob)[i].tm);
					strncpy(s, ((DUSTRING *)blob)[i].str, 80);
					add_index_string(tmp_arr, 4, s, 1);
					add_index_zval(return_value, i, tmp_arr);
				}
				break;
			case CF_SPECTRUM:  /* will we have more than one of these returned ?? */
				for (i = 0; i < size; i++) 
				{
					zval *tmp_arr;
					MAKE_STD_ZVAL(tmp_arr);
					array_init(tmp_arr);
					strncpy(s, ((DSPECTRUM *)blob)[i].comment, 80);
					add_index_string(tmp_arr, 0, s, 1);
					add_index_long(tmp_arr, 1, ((DSPECTRUM *)blob)[i].tm);
					add_index_double(tmp_arr, 2, ((DSPECTRUM *)blob)[i].s_start);
					add_index_double(tmp_arr, 3, ((DSPECTRUM *)blob)[i].s_inc);
					add_index_long(tmp_arr, 4, ((DSPECTRUM *)blob)[i].status);
					for (j = 0; j < 1024; j++)
						add_index_double(tmp_arr, j + 5, ((DSPECTRUM *)blob)[i].d_spect_array[j]);
					add_index_zval(return_value, i, tmp_arr);
				}
				break;			
			default: 
				RETURN_STRING("Format type not implemented", 1);
		}

        return;
    }
	else
		RETURN_STRING(GetRPCLastError(cc), 1);
}

ZEND_FUNCTION(tine_info)
{
	char *parm, *prop;
	int s_len;
	short cc;
	float max, min;
	char egu[80];
	PropertyQueryStruct props;

	if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ss", &parm, &s_len, &prop, &s_len) == FAILURE) return;

	if ((cc = GetPropertyInformation(parm, prop, &props)) != 0) RETURN_STRING(GetRPCLastError(cc), 1);

	if ((cc = GetDevicePropertyEGU(parm, prop, &max, &min, egu)) != 0) RETURN_STRING(GetRPCLastError(cc), 1);

	array_init(return_value);

	add_index_string(return_value, 0, parm, 1);
	add_index_string(return_value, 1, props.prpName, 1);
	add_index_string(return_value, 2, props.prpDescription, 1);
	add_index_long(return_value, 3, props.prpSize);
	add_index_string(return_value, 4, itof(props.prpFormat), 1);
	add_index_double(return_value, 5, max);
	add_index_double(return_value, 6, min);
	add_index_string(return_value, 7, egu, 1);

	return;
}

ZEND_FUNCTION(tine_put)
{
	char *parm, *prop;
	zval *arr, **data;
	int s_len;
	HashTable *arr_hash;
	HashPosition pointer;
	int array_count, i =0;
	double blob[8000];
	PropertyQueryStruct props;
	short cc;

	if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ssz", &parm, &s_len, &prop, &s_len, &arr) == FAILURE) return;

	if ((cc = GetPropertyInformation(parm, prop, &props)) != 0) RETURN_STRING(GetRPCLastError(cc), 1);

	convert_to_array_ex(&arr);

	arr_hash = Z_ARRVAL_P(arr);
    array_count = zend_hash_num_elements(arr_hash);

	for(zend_hash_internal_pointer_reset_ex(arr_hash, &pointer); zend_hash_get_current_data_ex
		(arr_hash, (void**) &data, &pointer) == SUCCESS; zend_hash_move_forward_ex(arr_hash, &pointer)) 
	{
		switch (LFMT(props.prpFormat))
		{
			case CF_BYTE:
				if (Z_TYPE_PP(data) == IS_LONG)
					((BYTE*)(blob))[i] = (BYTE)Z_LVAL_PP(data);
				else
				{
					php_error_docref(NULL TSRMLS_CC, E_WARNING,"Illegal data value @ index %d", i);
					return;
				}
				break;
			case CF_SHORT:
				if (Z_TYPE_PP(data) == IS_LONG)
					((short*)(blob))[i] = (short)Z_LVAL_PP(data);
				else
				{
					php_error_docref(NULL TSRMLS_CC, E_WARNING,"Illegal data value @ index %d", i);
					return;
				}
				break;
			case CF_LONG:
				if (Z_TYPE_PP(data) == IS_LONG)
					((long*)(blob))[i] = Z_LVAL_PP(data);
				else
				{
					php_error_docref(NULL TSRMLS_CC, E_WARNING,"Illegal data value @ index %d", i);
					return;
				}
				break;
			case CF_FLOAT:
				if (Z_TYPE_PP(data) == IS_DOUBLE)
					((float*)(blob))[i] = (float)Z_DVAL_PP(data);
				else
				{
					php_error_docref(NULL TSRMLS_CC, E_WARNING,"Illegal data value @ index %d", i);
					return;
				}
				break;
			case CF_DOUBLE:
				if (Z_TYPE_PP(data) == IS_DOUBLE)
					((double*)(blob))[i] = Z_DVAL_PP(data);
				else
				{
					php_error_docref(NULL TSRMLS_CC, E_WARNING,"Illegal data value @ index %d", i);
					return;
				}
				break;
			case CF_TEXT:
				if (Z_TYPE_PP(data) == IS_STRING)
					strncpy((char*)blob, Z_STRVAL_PP(data), Z_STRLEN_PP(data));
				else
				{
					php_error_docref(NULL TSRMLS_CC, E_WARNING,"Illegal data value @ index %d", i);
					return;
				}
				break;
			case CF_NAME16:
				if (Z_TYPE_PP(data) == IS_STRING)
					strncpy(((NAME16 *)blob)[i].name, Z_STRVAL_PP(data), 16);
				else
				{
					php_error_docref(NULL TSRMLS_CC, E_WARNING,"Illegal data value @ index %d", i);
					return;
				}
				break;
			case CF_NAME32:
				if (Z_TYPE_PP(data) == IS_STRING)
					strncpy(((NAME32 *)blob)[i].name, Z_STRVAL_PP(data), 32);
				else
				{
					php_error_docref(NULL TSRMLS_CC, E_WARNING,"Illegal data value @ index %d", i);
					return;
				}
				break;
			default:
				RETURN_STRING("Format type not implemented", 1);
		}

		i++;
    }

	RETURN_STRING(GetRPCLastError(_tput(blob, parm, prop, props.prpFormat, i, 5000)), 1); 
}